// UpdateCallbackConsole.h

#ifndef __UPDATECALLBACKCONSOLE_H
#define __UPDATECALLBACKCONSOLE_H

#include "../../../Common/StdOutStream.h"
#include "../../UI/Common/Update.h"

class CUpdateCallbackConsole: public IUpdateCallbackUI2
{
  bool m_NeedBeClosed;
  bool m_NeedNewLine;

  bool m_WarningsMode;

  CStdOutStream *OutStream;
public:
  bool EnablePercents;
  bool StdOutMode;

  #ifndef _NO_CRYPTO
  bool PasswordIsDefined;
  UString Password;
  bool AskPassword;
  #endif

  CUpdateCallbackConsole():
      PasswordIsDefined(false),
      AskPassword(false),
      StdOutMode(false),
      EnablePercents(true),
      m_WarningsMode(false)
      {}
  
  ~CUpdateCallbackConsole() { Finilize(); }
  void Init(CStdOutStream *outStream)
  {
    m_NeedBeClosed = false;
    m_NeedNewLine = false;
		m_TotalBytes = 0;
		m_ProgressCallback = NULL;
		m_UserData = NULL;
		m_CurrentFile = NULL;
    FailedFiles.Clear();
    FailedCodes.Clear();
    OutStream = outStream;
  }

  INTERFACE_IUpdateCallbackUI2(;)

  UStringVector FailedFiles;
  CRecordVector<HRESULT> FailedCodes;

  UStringVector CantFindFiles;
  CRecordVector<HRESULT> CantFindCodes;
  
	SEVENZIP_PROGRESS_PROC *m_ProgressCallback;
	void *m_UserData;

	TCHAR *m_CurrentFile;
	UInt64 m_TotalBytes;
};

#endif
